// Autor: Gerald Loacker, WolfVision Innovation GmbH
// SOPC Builder Interface fr NAND FLASH 512Mbit
// 18.01.2007

// synthesis translate_off
`timescale 1ns / 100ps
// synthesis translate_on
module nand_flash_if (
                // Host inputs
                iDATA,
                iALE,
                iCLE,
                iCE_N,
				iRE_N,
				iWE_N,
                iWP_N,

                // Host outputs
				oDATA,
                oRB,

                // NAND_FLASH signals
				ioNAND_DATA,
                oNAND_ALE,
                oNAND_CLE,
                oNAND_CE_N,
				oNAND_RE_N,
				oNAND_WE_N,
                oNAND_WP_N,
               	iNAND_RB
               );

  //Host side
  input	[7:0]	iDATA;
  input			iALE;
  input			iCLE;
  input			iCE_N;
  input			iRE_N;
  input			iWE_N;
  input			iWP_N;
  output [7:0]	oDATA;
  output		oRB;

  //NAND FLASH side
  inout	 [7:0]	ioNAND_DATA;
  output		oNAND_ALE;
  output		oNAND_CLE;
  output		oNAND_CE_N;
  output		oNAND_RE_N;
  output		oNAND_WE_N;
  output		oNAND_WP_N;
  input			iNAND_RB;
 
  assign	ioNAND_DATA	=	oNAND_WE_N	?	8'hzz	:	iDATA	;
  assign	oDATA		=	ioNAND_DATA;

  assign	oRB			=	iNAND_RB;
  assign	oNAND_ALE	=	iALE;
  assign	oNAND_CLE	=	iCLE;
  assign	oNAND_CE_N	=	iCE_N;
  assign	oNAND_RE_N	=	iRE_N;
  assign	oNAND_WE_N	=	iWE_N;
  assign	oNAND_WP_N	=	iWP_N;

endmodule

